import secrets
import string

#Erzeugen dreier Listen mit Zahlen, Buchstaben und Sonderzeichen
zahlenliste = string.digits
buchstabenliste = string.ascii_letters
sonderzeichenliste = string.punctuation

#Funktion, die einen Passwortvorschlag mit der Passwortlänge "anzahl" aus den vorgegebenen Zeichen ("zeichen") ausgibt
def vorschlag(anzahl, zeichen):
    passwort = ''
    for i in range (anzahl):
        #Hinzufügen der Zeichen, bis das Passwort die gewünschte Anzahl an Zeichen hat
        passwort = passwort + secrets.choice(zeichen)
    print("Ein Vorschlag für das Passwort ist: ",passwort)

#Hauptprogramm, das alle Benutzereingaben einliest und den Vorschlag erzeugt
def hauptprogramm():
    
    #Erzeugen einer leeren Liste, die später für die Zeichenauswahl für das Passwort genutzt wird
    zeichenauswahl = []

    #Benutzereingaben zu den Bedingungen, die das Passwort erfüllen soll
    eingabe_laenge=int(input("Gib die Länge des gewünschten Passworts ein: "))

    eingabe_zahlenErlaubt=input("Dürfen Zahlen in deinem Passwort vorkommen? J/N eingeben: ")
    #Prüfung, ob der Benutzer etwas anderes als "J" oder "N" eingegeben hat
    if eingabe_zahlenErlaubt != 'J' and eingabe_zahlenErlaubt != 'N':
        print("Ich erkenne deine Eingabe nicht. Mit Zahlen ist dein Passwort sicherer, deshalb füge ich welche hinzu.")
        eingabe_zahlenErlaubt = 'J'

    eingabe_sonderzeichenErlaubt=input("Dürfen Sonderzeichen in deinem Passwort vorkommen? J/N eingeben: ")
    #Prüfung, ob der Benutzer etwas anderes als "J" oder "N" eingegeben hat
    if eingabe_sonderzeichenErlaubt != 'J' and eingabe_sonderzeichenErlaubt != 'N':
        print("Ich erkenne deine Eingabe nicht. Mit Sonderzeichen ist dein Passwort sicherer, deshalb füge ich welche hinzu.")
        eingabe_sonderzeichenErlaubt = 'J'
    
    #Verketten der entsprechenden Listen, je nachdem ob der Benutzer Zahlen bzw. Sonderzeichen zulässt
    zeichenauswahl = buchstabenliste

    if eingabe_zahlenErlaubt == 'J':
        zeichenauswahl = zeichenauswahl + zahlenliste

    if eingabe_sonderzeichenErlaubt == 'J':
        zeichenauswahl = zeichenauswahl + sonderzeichenliste

    
    #Ausführen des Vorschlags mit vorgegebener Länge und den gewählten Zeichen
    vorschlag(eingabe_laenge, zeichenauswahl)


#Ausführen des Programms
hauptprogramm()
